package com.auth.example.config;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class NestBasedExample {

  public void outerPublic() {
    System.out.println("outer public example");
  }

  private void outerPrivate() {
    System.out.println("outer private example");
  }

  public class A {

    public void innerPublic() {
      System.out.println("inner public method");
    }

    public void innerPublicReflection(Object obj)
        throws NoSuchMethodException, InvocationTargetException, IllegalAccessException {
      System.out.println("inner public reflection");
      Method method = obj.getClass().getDeclaredMethod("outerPrivate");
      method.invoke(obj);
    }
  }

  public static void main(String[] args)
      throws InvocationTargetException, NoSuchMethodException, IllegalAccessException {
    NestBasedExample nestBasedExample = new NestBasedExample();
    NestBasedExample.A a = nestBasedExample.new A();
    a.innerPublic();
   // a.innerPublicReflection(nestBasedExample);
    System.out.println(NestBasedExample.class);
    System.out.println(A.class);
  }
}

